<template>
  <dashboard-layout title="Proprietaires">
    <div class="container-fluid" style="margin: 50px 0 0 0;">
      <div class="row">
        <div v-if="!creating && !editing" class="col-sm">
          <div class=" mb-5">
            <div class="row mb-5">
              <div class="col-sm-3"></div>
              <h3 class="text-center col-sm-6">Liste des Propriétaires</h3>
              <div class="text-right col-sm-3">
                <div class="form-group">
                  <input class="btn btn-light btn-block"
                    value="Ajouter" @click="creating = true"/>
                </div>
              </div>
            </div>
            <div class="">
              <div class="table-responsive">
                <div class="p-5" v-if="isLoading">
                  <fulfilling-bouncing-circle-spinner
                    class="mx-auto"
                    :animation-duration="2000"
                    :size="60"
                    :color="'#6D071A'"
                  />
                </div>
                <div v-else>
                  <div v-if="total != 0">
                    <table class="table rounded">
                      <thead>
                        <th>#</th>
                        <th>Nom Prénom(s)</th>
                        <th>Email</th>
                        <th>Phone</th>
                        <th>Agence Associée</th>
                        <th></th>
                      </thead>
                      <tbody>
                        <tr v-for="(proprio, i) in proprios" :key="i">
                          <td>{{ (curPage - 1) * perPage + i + 1 }}</td>
                          <td>{{ proprio.fullname }}</td>
                          <td>{{ proprio.email }}</td>
                          <td>{{ proprio.phone }}</td>
                          <td>{{ proprio.agence.name }}</td>
                          <td class="text-right">
                            <!-- 
                            <button type="button" class="btn btn-primary btn-sm mr-2"
                                @click="showProprio(proprio._id)>
                              <i class="fa fa-eye"></i>
                            </button>  --> 
                            <button
                              type="button"
                              class="btn btn-warning btn-sm mr-2"
                              @click="editProprio(proprio)">
                              <i class="fa fa-pencil"></i>
                            </button>
                            <button
                              type="button"
                              class="btn btn-danger btn-sm"
                              @click="removeProprio(proprio._id)">
                              <i class="fa fa-trash"></i>
                            </button>
                          </td>
                        </tr>
                      </tbody>
                    </table>
                  </div>
                  <div v-else>
                    <h4 class="text-center my-2">Aucun résultat trouvé !</h4>
                  </div>
                  
                </div>
              </div>
              <!-- 
              <div v-if="packs != null" class="px-2">
                <div class="tac d-flex flex-wrap">
                  <div class="justify-content-between row">
                    <pack-card
                      v-for="(pack, i) in packs"
                      :key="i"
                      :editPack="
                        () => {
                          editPack(pack);
                        }
                      "
                      :removePack="
                        () => {
                          removePack(pack._id);
                        }
                      "
                      :pack="pack"
                    />
                  </div>
                </div>
              </div>
              -->
            </div>
          </div>
        </div>
        <div class="col-sm-12 row" v-if="creating">
          <div class="col-sm-3"></div>
          <div class="card col-sm-6 rounded shadow">
            <div class="card-body">
              <div class="text-left cursor-p mb-2" @click="creating = false">
                <i class="fa fa-arrow-left mr-1"></i>
              </div>
              <hr />
              <h3 class="text-center">Ajouter un propriétaire</h3>
              <hr />
              <div class="alert alert-danger" v-if="errorMessage">
                {{ errorMessage }}
              </div>
              <form @submit="create">
                <div class="form-group">
                  <label>Nom et Prénom(s)</label>
                  <input
                    type="text"
                    min="0"
                    class="form-control"
                    v-model="newProprio.fullname"
                    placeholder="Nom et prénom du propriétaire."
                  />
                </div>
                <div class="form-group">
                  <label>Email</label>
                  <input
                    type="email"
                    class="form-control"
                    v-model="newProprio.email"
                    placeholder="Email du propriétaire."
                  />
                </div>
                <div class="form-group">
                  <label>Téléphone</label>
                  <input class="form-control" type="text"
                    v-model="newProprio.phone"
                    placeholder="Téléphone du propriétaire."
                  />
                </div>
                <div v-if="adminLog" class="form-group">
                  <label>{{ currentAgence }}</label>
                  <v-select
                    :options="agences"
                    :reduce="item => item.code"
                    class="form-control-select"
                    v-model="newProprio.agence"
                    required
                  ></v-select>
                </div>
                <div class="form-group">
                  <input type="submit" class="btn btn-light btn-block"
                    value="Ajouter" @click="creating = true"/>
                </div>
              </form>
            </div>
          </div>
        </div>
        <div class="col-sm-12 row" v-if="editing">
          <div class="col-sm-3"></div>
          <div class="card col-sm-6 rounded shadow">
            <div class="card-body">
              <div class="text-left cursor-p mb-2" @click="editing = false">
                <i class="fa fa-arrow-left mr-1"></i>
              </div>
              <hr />
              <h3 class="text-center">Modifier le propriétaire</h3>
              <hr />
              <div class="alert alert-danger" v-if="errorMessage">
                {{ errorMessage }}
              </div>
              <form @submit="update">
                <div class="form-group">
                  <label>Nom et Prénom(s)</label>
                  <input
                    type="text"
                    min="0"
                    class="form-control"
                    v-model="editingProprio.fullname"
                    placeholder="Nom et prénom du propriétaire."
                  />
                </div>
                <div class="form-group">
                  <label>Email</label>
                  <input
                    type="email"
                    class="form-control"
                    v-model="editingProprio.email"
                    placeholder="Email du propriétaire."
                  />
                </div>
                <div class="form-group">
                  <label for="">Téléphone</label>
                  <input class="form-control" type="text"
                    v-model="editingProprio.phone"
                    placeholder="Téléphone du propriétaire."
                  />
                </div>
                <div v-if="adminLog" class="form-group">
                  <label >Agences  </label>
                  <v-select
                    :options="agences"
                    :reduce="item => item.code"
                    class="form-control-select"
                    v-model="editingProprio.agence"
                    required
                  ></v-select>
                </div>
                <div v-else class="form-group">
                  <br><br><br>
                  <input class="form-control" type="text"
                    v-model="currentAgence"/>
                </div>
                <div class="form-group">
                  <input type="submit" class="btn btn-light btn-block"
                    value="Modifier"/>
                </div>
              </form>
            </div>
          </div>
        </div>
      </div>
    </div>
  </dashboard-layout>
</template>

<script>
export default {
  name: "home",
  data() {
    return {
      proprios: [],
      agences: [],
      isLoading: false,
      creating: false,
      editing: false,
      errorMessage: "",
      curPage: 1,
      perPage: 100,
      newProprio: {
        agence: '',
      },
      adminLog: false,
      editingProprio: {
        agence: '',
      },
      total: 0,
      userDatas: "",
      editingId:'',
      currentAgence: '',

      center: {},
    };
  },
  mounted() {
    this.init();
    this.userDatas = JSON.parse(localStorage.getItem("adminInfo"));
    if (localStorage.getItem("adminRole") == 'agence' ){
      this.newProprio.agence = localStorage.getItem("adminId");
      this.editingProprio.agence = localStorage.getItem("adminId");
    }else{
      this.adminLog = true;
      this.getAgences();
    }

    navigator.geolocation.getCurrentPosition(position => {
      this.center = {
        latitude: position.coords.latitude,
        longitude: position.coords.longitude,
      };
    });
  },
  methods: {
    init(page, resetParams) {
      if (resetParams) {
        this.curPage = 1;
      }
      
      let query = query = {
        options: {},
        sort: {
          createdAt: -1,
        },
      };
      

      if(localStorage.getItem("adminRole") == 'agence')
        query.options.agence = localStorage.getItem("adminId");

      this.isLoading = true;

      this.$service.list("proprietaires", query, (err, data) => {
        if (err) {
          return console.log(err);
        }
        //console.log('results',data)
        this.isLoading = false;
        this.errorMessage = "";
        this.proprios = data.proprietaires;
        this.total = data.proprietaires.length;
      });
    },
    getAgences(){
      const query = {
        options: {
          role: "agence",
        },
        page: 0,
        perPage: 100
      };

      this.$service.listAdmins(query, (err, data) => {
        if (err) {
          console.log(err);
          return;
        }
        this.errorMessage = "";
        this.agences = data.admins.map(admin => {
          return {
            label: admin.name + " - " + admin.address,
            code: admin._id
          };
        });
      });
    },
    create(e) {
      console.log("dans create", this.newProprio);
      e.preventDefault();
      this.$service.create("proprietaires", this.newProprio, (err, data) => {
        if (err) {
          this.errorMessage = err.data && err.data.message;
          console.log("Error", err.data);
          return;
        }
        
        this.newProprio = {
          fullname: '0',
          email: '0',
          phone: "",
          agence: ""
        };

        let datas = {
          admin : localStorage.getItem("adminId"),

          message: 'create proprietaire',
          date: new Date(),
          position : this.center,
        }
        this.$service.create("historiques", datas, (err, data) => {
          if (err) {
            this.errorMessage = err.data && err.data.message;
            return;
          }
          this.editing = this.creating = false;
          this.$swal.fire("Ajout réussie", "", "success").then(() => {
            this.init();
          });
        });
      });
    },
    editProprio(proprio) {
      this.editingId = proprio._id;
      this.editingProprio.fullname = proprio.fullname;
      this.editingProprio.email = proprio.email;
      this.editingProprio.phone = proprio.phone;
      this.editingProprio.agence = proprio.agence._id;
      this.currentAgence = "Agence actuelle : " +proprio.agence.name;

      this.editing = true;
    },
    update(e) {
      e.preventDefault();
      this.$service.update("proprietaires",this.editingId,this.editingProprio, (err, data) => {
          if (err) {
            this.errorMessage = err.data && err.data.message;
            console.log("Error", err.data);
            return;
          }
          this.editing = this.creating =  false;

          this.editingProprio = {
            fullname: '0',
            email: '0',
            phone: "",
            agence: ""
          };

          let datas = {
            admin : localStorage.getItem("adminId"),

            message: 'edit proprietaire',
            date: new Date(),
            position : this.center,
          };
          this.$service.create("historiques", datas, (err, data) => {
            if (err) {
              this.errorMessage = err.data && err.data.message;
              return;
            }
            
            this.editing = this.creating = false;
            this.$swal.fire("Modification réussie", "", "success").then(() => {
              this.init();
            });
          });
        }
      );
    },
    removeProprio(id) {
      this.$swal
        .fire({
          title: "Voulez-vous vraiment supprimer?",
          text: "Vous ne pouvez plus récuperer ces données !",
          icon: "warning",
          showCancelButton: true,
          cancelButtonColor: "#3085d6",
          confirmButtonColor: "#d33",
          confirmButtonText: "Oui, supprimer!",
        })
        .then((result) => {
          if (result.value) {
            this.$service.remove("proprietaires", id, (err, data) => {
              if (err) {
                this.errorMessage = err.data && err.data.message;
                console.log("Error", err.data);
                return;
              }

              let datas = {
                admin : localStorage.getItem("adminId"),

                message: 'remove proprietaire',
                date: new Date(),
                position : this.center,
              };
              this.$service.create("historiques", datas, (err, data) => {
                if (err) {
                  this.errorMessage = err.data && err.data.message;
                  return;
                }
                
                this.$swal
                .fire( "Suppression réussie", "La suppression s'est effectuée avec succès", "success" )
                .then(() => { this.init(); }); 
              });
            });
          }
        });
    },
  },
};
</script>